var xmldoc = require('xmldoc');
var exec = require('shelljs').exec;

function getAuthor (data, lineNumber) {
	var blame, entry, author;
	blame = new xmldoc.XmlDocument(data).children[0];
	entry = blame.childWithAttribute('line-number', lineNumber.toString());
	if(!entry){
		return null;
	}
	if(!entry.childNamed('commit')){
		return null;
	}
	return entry.childNamed('commit').childNamed('author').val;
};

function getLines(data, author) {
	var blame, entries, i, result= [], entriesNum;
	blame = new xmldoc.XmlDocument(data).children[0];

	entries = blame.childrenNamed('entry');
	entriesNum = entries.length;
	for (i = 0; i < entriesNum; i++){
		if(entries[i].descendantWithPath('commit.author').val === author){
			result.push(entries[i].attr['line-number']);
		}
	}
	return result;
}

function getAllAuthors (data) {
	var blame, authors, result = [], i;
	blame = new xmldoc.XmlDocument(data).children[0];
	entries = blame.childrenNamed('entry');
	entriesNum = entries.length;
	for (i = 0; i < entriesNum; i++){
		if(result.indexOf(entries[i].descendantWithPath('commit.author').val) < 0){
			result.push(entries[i].descendantWithPath('commit.author').val);
		}
	}
	return result;
}


function blame(credentials, path) {
	var buff;
  var _path = path || '.';
  if(credentials) {
  	 var user = credentials.username ? " --username " + credentials.username : "";
 	 var password = credentials.password ? " --password " + credentials.password : "";
  }
 
  var cmd = exec('svn blame ' + path + ' --xml ' + user + password, {
    silent: true
  })
  if(cmd.code !== 0) {
    throw new Error('A Error occur when executing "blame" at' + path + '\n' + cmd.output)
  }
  	buff = cmd.output;
  	buff = buff.replace(/(\r\n|\n|\r)/gm,"");
	start = buff.indexOf(">") + 1;
	buff = buff.substr(start , buff.length - start);

  return buff;
}

module.exports = {
	getAuthor: getAuthor,
	getLines: getLines,
	getAllAuthors: getAllAuthors,
	blame: blame
}
